submodule: Fix t7400, t7405, t7406 for msysGit
[git/dscho.git] / git-am.sh
blob2d96e4a3daba6a95d6599880724d8e18a74cb8e1
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
14 q,quiet be quiet
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
19 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
20 c,scissors strip everything before a scissors line
21 whitespace= pass it through git-apply
22 ignore-space-change pass it through git-apply
23 ignore-whitespace pass it through git-apply
24 directory= pass it through git-apply
25 exclude= pass it through git-apply
26 C= pass it through git-apply
27 p= pass it through git-apply
28 patch-format= format the patch(es) are in
29 reject pass it through git-apply
30 resolvemsg= override error message when patch failure occurs
31 continue continue applying patches after resolving a conflict
32 r,resolved synonyms for --continue
33 skip skip the current patch
34 abort restore the original branch and abort the patching operation.
35 committer-date-is-author-date lie about committer date
36 ignore-date use current timestamp for author date
37 rerere-autoupdate update the index with reused conflict resolution if possible
38 rebasing* (internal use for git-rebase)"
40 . git-sh-setup
41 . git-sh-i18n
42 prefix=$(git rev-parse --show-prefix)
43 set_reflog_action am
44 require_work_tree
45 cd_to_toplevel
47 git var GIT_COMMITTER_IDENT >/dev/null ||
48 die "$(gettext "You need to set your committer info first")"
50 if git rev-parse --verify -q HEAD >/dev/null
51 then
52 HAS_HEAD=yes
53 else
54 HAS_HEAD=
57 cmdline="git am"
58 if test '' != "$interactive"
59 then
60 cmdline="$cmdline -i"
62 if test '' != "$threeway"
63 then
64 cmdline="$cmdline -3"
67 sq () {
68 git rev-parse --sq-quote "$@"
71 stop_here () {
72 echo "$1" >"$dotest/next"
73 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
74 exit 1
77 safe_to_abort () {
78 if test -f "$dotest/dirtyindex"
79 then
80 return 1
83 if ! test -s "$dotest/abort-safety"
84 then
85 return 0
88 abort_safety=$(cat "$dotest/abort-safety")
89 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
90 then
91 return 0
94 gettext "You seem to have moved HEAD since the last 'am' failure.
95 Not rewinding to ORIG_HEAD" &&
96 echo
97 ) >&2
98 return 1
101 stop_here_user_resolve () {
102 if [ -n "$resolvemsg" ]; then
103 printf '%s\n' "$resolvemsg"
104 stop_here $1
106 eval_gettext "When you have resolved this problem run \"\$cmdline --resolved\".
107 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
108 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
110 stop_here $1
113 go_next () {
114 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
115 "$dotest/patch" "$dotest/info"
116 echo "$next" >"$dotest/next"
117 this=$next
120 cannot_fallback () {
121 echo "$1"
122 gettext "Cannot fall back to three-way merge."; echo
123 exit 1
126 fall_back_3way () {
127 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
129 rm -fr "$dotest"/patch-merge-*
130 mkdir "$dotest/patch-merge-tmp-dir"
132 # First see if the patch records the index info that we can use.
133 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
134 "$dotest/patch" &&
135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136 git write-tree >"$dotest/patch-merge-base+" ||
137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
139 say Using index info to reconstruct a base tree...
140 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
141 git apply --cached <"$dotest/patch"
142 then
143 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
144 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
145 else
146 cannot_fallback "$(gettext "Did you hand edit your patch?
147 It does not apply to blobs recorded in its index.")"
150 test -f "$dotest/patch-merge-index" &&
151 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
152 orig_tree=$(cat "$dotest/patch-merge-base") &&
153 rm -fr "$dotest"/patch-merge-* || exit 1
155 say "$(gettext "Falling back to patching base and 3-way merge...")"
157 # This is not so wrong. Depending on which base we picked,
158 # orig_tree may be wildly different from ours, but his_tree
159 # has the same set of wildly different changes in parts the
160 # patch did not touch, so recursive ends up canceling them,
161 # saying that we reverted all those changes.
163 eval GITHEAD_$his_tree='"$FIRSTLINE"'
164 export GITHEAD_$his_tree
165 if test -n "$GIT_QUIET"
166 then
167 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
169 git-merge-recursive $orig_tree -- HEAD $his_tree || {
170 git rerere $allow_rerere_autoupdate
171 echo Failed to merge in the changes.
172 exit 1
174 unset GITHEAD_$his_tree
177 clean_abort () {
178 test $# = 0 || echo >&2 "$@"
179 rm -fr "$dotest"
180 exit 1
183 patch_format=
185 check_patch_format () {
186 # early return if patch_format was set from the command line
187 if test -n "$patch_format"
188 then
189 return 0
192 # we default to mbox format if input is from stdin and for
193 # directories
194 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
195 then
196 patch_format=mbox
197 return 0
200 # otherwise, check the first few lines of the first patch to try
201 # to detect its format
203 read l1
204 read l2
205 read l3
206 case "$l1" in
207 "From "* | "From: "*)
208 patch_format=mbox
210 '# This series applies on GIT commit'*)
211 patch_format=stgit-series
213 "# HG changeset patch")
214 patch_format=hg
217 # if the second line is empty and the third is
218 # a From, Author or Date entry, this is very
219 # likely an StGIT patch
220 case "$l2,$l3" in
221 ,"From: "* | ,"Author: "* | ,"Date: "*)
222 patch_format=stgit
226 esac
228 esac
229 if test -z "$patch_format" &&
230 test -n "$l1" &&
231 test -n "$l2" &&
232 test -n "$l3"
233 then
234 # This begins with three non-empty lines. Is this a
235 # piece of e-mail a-la RFC2822? Grab all the headers,
236 # discarding the indented remainder of folded lines,
237 # and see if it looks like that they all begin with the
238 # header field names...
239 tr -d '\015' <"$1" |
240 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
241 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
242 patch_format=mbox
244 } < "$1" || clean_abort
247 split_patches () {
248 case "$patch_format" in
249 mbox)
250 if test -n "$rebasing" || test t = "$keepcr"
251 then
252 keep_cr=--keep-cr
253 else
254 keep_cr=
256 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
257 clean_abort
259 stgit-series)
260 if test $# -ne 1
261 then
262 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
264 series_dir=`dirname "$1"`
265 series_file="$1"
266 shift
268 set x
269 while read filename
271 set "$@" "$series_dir/$filename"
272 done
273 # remove the safety x
274 shift
275 # remove the arg coming from the first-line comment
276 shift
277 } < "$series_file" || clean_abort
278 # set the patch format appropriately
279 patch_format=stgit
280 # now handle the actual StGIT patches
281 split_patches "$@"
283 stgit)
284 this=0
285 for stgit in "$@"
287 this=`expr "$this" + 1`
288 msgnum=`printf "%0${prec}d" $this`
289 # Perl version of StGIT parse_patch. The first nonemptyline
290 # not starting with Author, From or Date is the
291 # subject, and the body starts with the next nonempty
292 # line not starting with Author, From or Date
293 perl -ne 'BEGIN { $subject = 0 }
294 if ($subject > 1) { print ; }
295 elsif (/^\s+$/) { next ; }
296 elsif (/^Author:/) { print s/Author/From/ ; }
297 elsif (/^(From|Date)/) { print ; }
298 elsif ($subject) {
299 $subject = 2 ;
300 print "\n" ;
301 print ;
302 } else {
303 print "Subject: ", $_ ;
304 $subject = 1;
306 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
307 done
308 echo "$this" > "$dotest/last"
309 this=
310 msgnum=
313 if test -n "$parse_patch" ; then
314 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
315 else
316 clean_abort "$(gettext "Patch format detection failed.")"
319 esac
322 prec=4
323 dotest="$GIT_DIR/rebase-apply"
324 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
325 resolvemsg= resume= scissors= no_inbody_headers=
326 git_apply_opt=
327 committer_date_is_author_date=
328 ignore_date=
329 allow_rerere_autoupdate=
331 if test "$(git config --bool --get am.keepcr)" = true
332 then
333 keepcr=t
336 while test $# != 0
338 case "$1" in
339 -i|--interactive)
340 interactive=t ;;
341 -b|--binary)
342 : ;;
343 -3|--3way)
344 threeway=t ;;
345 -s|--signoff)
346 sign=t ;;
347 -u|--utf8)
348 utf8=t ;; # this is now default
349 --no-utf8)
350 utf8= ;;
351 -k|--keep)
352 keep=t ;;
353 -c|--scissors)
354 scissors=t ;;
355 --no-scissors)
356 scissors=f ;;
357 -r|--resolved|--continue)
358 resolved=t ;;
359 --skip)
360 skip=t ;;
361 --abort)
362 abort=t ;;
363 --rebasing)
364 rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
365 -d|--dotest)
366 die "$(gettext "-d option is no longer supported. Do not use.")"
368 --resolvemsg)
369 shift; resolvemsg=$1 ;;
370 --whitespace|--directory|--exclude)
371 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
372 -C|-p)
373 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
374 --patch-format)
375 shift ; patch_format="$1" ;;
376 --reject|--ignore-whitespace|--ignore-space-change)
377 git_apply_opt="$git_apply_opt $1" ;;
378 --committer-date-is-author-date)
379 committer_date_is_author_date=t ;;
380 --ignore-date)
381 ignore_date=t ;;
382 --rerere-autoupdate|--no-rerere-autoupdate)
383 allow_rerere_autoupdate="$1" ;;
384 -q|--quiet)
385 GIT_QUIET=t ;;
386 --keep-cr)
387 keepcr=t ;;
388 --no-keep-cr)
389 keepcr=f ;;
391 shift; break ;;
393 usage ;;
394 esac
395 shift
396 done
398 # If the dotest directory exists, but we have finished applying all the
399 # patches in them, clear it out.
400 if test -d "$dotest" &&
401 last=$(cat "$dotest/last") &&
402 next=$(cat "$dotest/next") &&
403 test $# != 0 &&
404 test "$next" -gt "$last"
405 then
406 rm -fr "$dotest"
409 if test -d "$dotest"
410 then
411 case "$#,$skip$resolved$abort" in
412 0,*t*)
413 # Explicit resume command and we do not have file, so
414 # we are happy.
415 : ;;
417 # No file input but without resume parameters; catch
418 # user error to feed us a patch from standard input
419 # when there is already $dotest. This is somewhat
420 # unreliable -- stdin could be /dev/null for example
421 # and the caller did not intend to feed us a patch but
422 # wanted to continue unattended.
423 test -t 0
426 false
428 esac ||
429 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
430 resume=yes
432 case "$skip,$abort" in
433 t,t)
434 die "$(gettext "Please make up your mind. --skip or --abort?")"
437 git rerere clear
438 git read-tree --reset -u HEAD HEAD
439 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
440 git reset HEAD
441 git update-ref ORIG_HEAD $orig_head
444 if test -f "$dotest/rebasing"
445 then
446 exec git rebase --abort
448 git rerere clear
449 if safe_to_abort
450 then
451 git read-tree --reset -u HEAD ORIG_HEAD
452 git reset ORIG_HEAD
454 rm -fr "$dotest"
455 exit ;;
456 esac
457 rm -f "$dotest/dirtyindex"
458 else
459 # Make sure we are not given --skip, --resolved, nor --abort
460 test "$skip$resolved$abort" = "" ||
461 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
463 # Start afresh.
464 mkdir -p "$dotest" || exit
466 if test -n "$prefix" && test $# != 0
467 then
468 first=t
469 for arg
471 test -n "$first" && {
472 set x
473 first=
475 if is_absolute_path "$arg"
476 then
477 set "$@" "$arg"
478 else
479 set "$@" "$prefix$arg"
481 done
482 shift
485 check_patch_format "$@"
487 split_patches "$@"
489 # -i can and must be given when resuming; everything
490 # else is kept
491 echo " $git_apply_opt" >"$dotest/apply-opt"
492 echo "$threeway" >"$dotest/threeway"
493 echo "$sign" >"$dotest/sign"
494 echo "$utf8" >"$dotest/utf8"
495 echo "$keep" >"$dotest/keep"
496 echo "$keepcr" >"$dotest/keepcr"
497 echo "$scissors" >"$dotest/scissors"
498 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
499 echo "$GIT_QUIET" >"$dotest/quiet"
500 echo 1 >"$dotest/next"
501 if test -n "$rebasing"
502 then
503 : >"$dotest/rebasing"
504 else
505 : >"$dotest/applying"
506 if test -n "$HAS_HEAD"
507 then
508 git update-ref ORIG_HEAD HEAD
509 else
510 git update-ref -d ORIG_HEAD >/dev/null 2>&1
515 case "$resolved" in
517 case "$HAS_HEAD" in
519 files=$(git ls-files) ;;
521 files=$(git diff-index --ignore-submodules --cached \
522 --name-only HEAD --) ;;
523 esac || exit
524 if test "$files"
525 then
526 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
527 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
529 esac
531 if test "$(cat "$dotest/utf8")" = t
532 then
533 utf8=-u
534 else
535 utf8=-n
537 if test "$(cat "$dotest/keep")" = t
538 then
539 keep=-k
541 case "$(cat "$dotest/keepcr")" in
543 keepcr=--keep-cr ;;
545 keepcr=--no-keep-cr ;;
546 esac
547 case "$(cat "$dotest/scissors")" in
549 scissors=--scissors ;;
551 scissors=--no-scissors ;;
552 esac
553 if test "$(cat "$dotest/no_inbody_headers")" = t
554 then
555 no_inbody_headers=--no-inbody-headers
556 else
557 no_inbody_headers=
559 if test "$(cat "$dotest/quiet")" = t
560 then
561 GIT_QUIET=t
563 if test "$(cat "$dotest/threeway")" = t
564 then
565 threeway=t
567 git_apply_opt=$(cat "$dotest/apply-opt")
568 if test "$(cat "$dotest/sign")" = t
569 then
570 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
571 s/>.*/>/
572 s/^/Signed-off-by: /'
574 else
575 SIGNOFF=
578 last=`cat "$dotest/last"`
579 this=`cat "$dotest/next"`
580 if test "$skip" = t
581 then
582 this=`expr "$this" + 1`
583 resume=
586 while test "$this" -le "$last"
588 msgnum=`printf "%0${prec}d" $this`
589 next=`expr "$this" + 1`
590 test -f "$dotest/$msgnum" || {
591 resume=
592 go_next
593 continue
596 # If we are not resuming, parse and extract the patch information
597 # into separate files:
598 # - info records the authorship and title
599 # - msg is the rest of commit log message
600 # - patch is the patch body.
602 # When we are resuming, these files are either already prepared
603 # by the user, or the user can tell us to do so by --resolved flag.
604 case "$resume" in
606 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
607 <"$dotest/$msgnum" >"$dotest/info" ||
608 stop_here $this
610 # skip pine's internal folder data
611 sane_grep '^Author: Mail System Internal Data$' \
612 <"$dotest"/info >/dev/null &&
613 go_next && continue
615 test -s "$dotest/patch" || {
616 eval_gettext "Patch is empty. Was it split wrong?
617 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
618 To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
619 stop_here $this
621 rm -f "$dotest/original-commit" "$dotest/author-script"
622 if test -f "$dotest/rebasing" &&
623 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
624 -e q "$dotest/$msgnum") &&
625 test "$(git cat-file -t "$commit")" = commit
626 then
627 git cat-file commit "$commit" |
628 sed -e '1,/^$/d' >"$dotest/msg-clean"
629 echo "$commit" > "$dotest/original-commit"
630 get_author_ident_from_commit "$commit" > "$dotest/author-script"
631 else
633 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
634 echo
635 cat "$dotest/msg"
637 git stripspace > "$dotest/msg-clean"
640 esac
642 if test -f "$dotest/author-script"
643 then
644 eval $(cat "$dotest/author-script")
645 else
646 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
647 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
648 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
651 if test -z "$GIT_AUTHOR_EMAIL"
652 then
653 gettext "Patch does not have a valid e-mail address."; echo
654 stop_here $this
657 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
659 case "$resume" in
661 if test '' != "$SIGNOFF"
662 then
663 LAST_SIGNED_OFF_BY=`
664 sed -ne '/^Signed-off-by: /p' \
665 "$dotest/msg-clean" |
666 sed -ne '$p'
668 ADD_SIGNOFF=`
669 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
670 test '' = "$LAST_SIGNED_OFF_BY" && echo
671 echo "$SIGNOFF"
673 else
674 ADD_SIGNOFF=
677 if test -s "$dotest/msg-clean"
678 then
679 cat "$dotest/msg-clean"
681 if test '' != "$ADD_SIGNOFF"
682 then
683 echo "$ADD_SIGNOFF"
685 } >"$dotest/final-commit"
688 case "$resolved$interactive" in
690 # This is used only for interactive view option.
691 git diff-index --ignore-submodules -p --cached \
692 HEAD -- >"$dotest/patch"
694 esac
695 esac
697 resume=
698 if test "$interactive" = t
699 then
700 test -t 0 ||
701 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
702 action=again
703 while test "$action" = again
705 gettext "Commit Body is:"; echo
706 echo "--------------------------"
707 cat "$dotest/final-commit"
708 echo "--------------------------"
709 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
710 # in your translation. The program will only accept English
711 # input at this point.
712 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
713 read reply
714 case "$reply" in
715 [yY]*) action=yes ;;
716 [aA]*) action=yes interactive= ;;
717 [nN]*) action=skip ;;
718 [eE]*) git_editor "$dotest/final-commit"
719 action=again ;;
720 [vV]*) action=again
721 git_pager "$dotest/patch" ;;
722 *) action=again ;;
723 esac
724 done
725 else
726 action=yes
729 if test -f "$dotest/final-commit"
730 then
731 FIRSTLINE=$(sed 1q "$dotest/final-commit")
732 else
733 FIRSTLINE=""
736 if test $action = skip
737 then
738 go_next
739 continue
742 if test -x "$GIT_DIR"/hooks/applypatch-msg
743 then
744 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
745 stop_here $this
748 say "$(eval_gettext "Applying: \$FIRSTLINE")"
750 case "$resolved" in
752 # When we are allowed to fall back to 3-way later, don't give
753 # false errors during the initial attempt.
754 squelch=
755 if test "$threeway" = t
756 then
757 squelch='>/dev/null 2>&1 '
759 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
760 apply_status=$?
763 # Resolved means the user did all the hard work, and
764 # we do not have to do any patch application. Just
765 # trust what the user has in the index file and the
766 # working tree.
767 resolved=
768 git diff-index --ignore-submodules --quiet --cached HEAD -- && {
769 gettext "No changes - did you forget to use 'git add'?
770 If there is nothing left to stage, chances are that something else
771 already introduced the same changes; you might want to skip this patch."; echo
772 stop_here_user_resolve $this
774 unmerged=$(git ls-files -u)
775 if test -n "$unmerged"
776 then
777 gettext "You still have unmerged paths in your index
778 did you forget to use 'git add'?"; echo
779 stop_here_user_resolve $this
781 apply_status=0
782 git rerere
784 esac
786 if test $apply_status != 0 && test "$threeway" = t
787 then
788 if (fall_back_3way)
789 then
790 # Applying the patch to an earlier tree and merging the
791 # result may have produced the same tree as ours.
792 git diff-index --ignore-submodules --quiet --cached \
793 HEAD -- && {
794 say "$(gettext "No changes -- Patch already applied.")"
795 go_next
796 continue
798 # clear apply_status -- we have successfully merged.
799 apply_status=0
802 if test $apply_status != 0
803 then
804 eval_gettext 'Patch failed at $msgnum $FIRSTLINE'; echo
805 stop_here_user_resolve $this
808 if test -x "$GIT_DIR"/hooks/pre-applypatch
809 then
810 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
813 tree=$(git write-tree) &&
814 commit=$(
815 if test -n "$ignore_date"
816 then
817 GIT_AUTHOR_DATE=
819 parent=$(git rev-parse --verify -q HEAD) ||
820 say >&2 "$(gettext "applying to an empty history")"
822 if test -n "$committer_date_is_author_date"
823 then
824 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
825 export GIT_COMMITTER_DATE
826 fi &&
827 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
828 ) &&
829 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
830 stop_here $this
832 if test -f "$dotest/original-commit"; then
833 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
836 if test -x "$GIT_DIR"/hooks/post-applypatch
837 then
838 "$GIT_DIR"/hooks/post-applypatch
841 go_next
842 done
844 if test -s "$dotest"/rewritten; then
845 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
846 if test -x "$GIT_DIR"/hooks/post-rewrite; then
847 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
851 rm -fr "$dotest"
852 git gc --auto